ALTER TABLE DHCP_PKTS4 DROP PKT;
ALTER TABLE DHCP_PKTS6 DROP PKT;

ALTER TABLE DHCP_PKTS4 ADD PKT VARCHAR (8192) CHARACTER SET ISO8859_1;
ALTER TABLE DHCP_PKTS6 ADD PKT VARCHAR (8192) CHARACTER SET ISO8859_1;

ALTER TABLE DHCP_PKTS4 ADD CONSTRAINT PK_PKTS4_UNQ UNIQUE (PRIMARY_ID,PKT_TYPE);

CREATE TABLE WSI_SQL_TARGET (
    PK PK_TYPE NOT NULL,
    NAME VALID_GENERAL_NAME COLLATE ISO8859_1);

CREATE TABLE WSI_SQL_TARGET_LINKS (
    PK PK_TYPE NOT NULL,
    SRC_ATTR_NAME GENERAL_NAME COLLATE ISO8859_1,
    DEST_ATTR_NAME GENERAL_NAME COLLATE ISO8859_1,
    SRC_ATTR_REF FOREIGN_KEY_ID,
    DEST_ATTR_REF FOREIGN_KEY_ID,
    SRC_ATTR_REF_CL CLASS_NAME COLLATE ISO8859_1,
    DEST_ATTR_REF_CL CLASS_NAME COLLATE ISO8859_1,
    DEST_NAME_KEY GENERAL_NAME COLLATE ISO8859_1,
    DEST_SEQ_KEY INDEX_TYPE);

ALTER TABLE WSI_SQL_TARGET ADD CONSTRAINT PK_SQL_TARGET PRIMARY KEY(PK);
ALTER TABLE WSI_SQL_TARGET_LINKS ADD CONSTRAINT PK_SQL_TARGET_LINKS PRIMARY KEY(PK);

CREATE UNIQUE DESCENDING INDEX IDX_SQL_TARGET ON WSI_SQL_TARGET(PK);
CREATE UNIQUE DESCENDING INDEX IDX_SQL_TARGET_LINKS ON WSI_SQL_TARGET_LINKS(PK);

CREATE SEQUENCE WSI_SQL_TARGET;
CREATE SEQUENCE WSI_SQL_TARGET_LINKS;

ALTER TABLE WSI_SQL_TARGET_LINKS ADD CONSTRAINT FK_SQL_TARGET_LINKS_DEST FOREIGN KEY (DEST_ATTR_REF) REFERENCES WSI_SQL_TARGET (PK);
ALTER TABLE WSI_SQL_TARGET_LINKS ADD CONSTRAINT FK_SQL_TARGET_LINKS_SRC FOREIGN KEY (SRC_ATTR_REF) REFERENCES WSI_SQL_QUERY (PK);

ALTER TABLE WSI_SQL_QUERY DROP TARGET_CLASS_NAME;
ALTER TABLE WSI_SQL_QUERY ADD TAG GENERAL_NAME COLLATE ISO8859_1;
ALTER TABLE WSI_SQL_QUERY ADD TARGET_CLASSES FOREIGN_KEY_ID;
ALTER TABLE WSI_SQL_QUERY ADD TARGET_CLASSES_SC SELECT_CRITERIA COLLATE ISO8859_1;
ALTER TABLE WSI_SQL_QUERY ADD QID ID_TYPE NOT NULL UNIQUE;

CREATE UNIQUE ASCENDING INDEX IDX_SQL_QUERY_QID ON WSI_SQL_QUERY(QID);

CREATE TABLE WSI_SNMP_GROUPS (
    PK PK_TYPE NOT NULL,
    OID ID_TYPE NOT NULL UNIQUE,
    MOD_TIME TIME_T,
    NAME VALID_GENERAL_NAME COLLATE ISO8859_1,
    DESCRIPTION LONG_TEXT,
    QUERY_MEMBERS FOREIGN_KEY_ID,
    QUERY_MEMBERS_SC SELECT_CRITERIA COLLATE ISO8859_1,
    SECURED_REF FOREIGN_KEY_ID,
    SECURED_REF_CL CLASS_NAME COLLATE ISO8859_1);

CREATE TABLE WSI_SNMP_QUERY (
    PK PK_TYPE NOT NULL,
    OID ID_TYPE NOT NULL UNIQUE,
    MOD_TIME TIME_T,
    NAME VALID_GENERAL_NAME COLLATE ISO8859_1,
    DESCRIPTION LONG_TEXT,
    PREFIX_NAME GENERAL_NAME COLLATE ISO8859_1,
    OBJECT_NAME GENERAL_NAME COLLATE ISO8859_1,
    GROUP_MEMBERS FOREIGN_KEY_ID,
    GROUP_MEMBERS_SC SELECT_CRITERIA COLLATE ISO8859_1,
    SECURED_REF FOREIGN_KEY_ID,
    SECURED_REF_CL CLASS_NAME COLLATE ISO8859_1);

CREATE TABLE WSI_SNMP_GRP_LINKS (
    PK PK_TYPE NOT NULL,
    SRC_ATTR_NAME GENERAL_NAME COLLATE ISO8859_1,
    DEST_ATTR_NAME GENERAL_NAME COLLATE ISO8859_1,
    SRC_ATTR_REF FOREIGN_KEY_ID,
    DEST_ATTR_REF FOREIGN_KEY_ID,
    SRC_ATTR_REF_CL CLASS_NAME COLLATE ISO8859_1,
    DEST_ATTR_REF_CL CLASS_NAME COLLATE ISO8859_1,
    BI_SRC_REF FOREIGN_KEY_ID,
    BI_DEST_REF FOREIGN_KEY_ID,
    BI_SRC_REF_CL CLASS_NAME COLLATE ISO8859_1,
    BI_DEST_REF_CL CLASS_NAME COLLATE ISO8859_1,
    DEST_NAME_KEY GENERAL_NAME COLLATE ISO8859_1,
    DEST_SEQ_KEY INDEX_TYPE,
    DEST_EXT_SEQ_KEY INDEX_TYPE);


ALTER TABLE WSI_SNMP_QUERY ADD CONSTRAINT PK_SNMP_QUERY PRIMARY KEY(PK);
ALTER TABLE WSI_SNMP_GROUPS ADD CONSTRAINT PK_SNMP_GROUP PRIMARY KEY(PK);
ALTER TABLE WSI_SNMP_GRP_LINKS ADD CONSTRAINT PK_SNMP_GRP_LINKS PRIMARY KEY(PK);

CREATE UNIQUE DESCENDING INDEX IDX_SNMP_QUERY ON WSI_SNMP_QUERY(PK);
CREATE UNIQUE DESCENDING INDEX IDX_SNMP_GROUP ON WSI_SNMP_GROUPS(PK);
CREATE UNIQUE DESCENDING INDEX IDX_SNMP_GRP_LINKS ON WSI_SNMP_GRP_LINKS(PK);

ALTER TABLE WSI_SNMP_GROUPS ADD CONSTRAINT FK_SNMP_GROUP_SECURED FOREIGN KEY (SECURED_REF) REFERENCES WSI_SECURED_OBJECT (PK);
ALTER TABLE WSI_SNMP_QUERY ADD CONSTRAINT FK_SNMP_QUERY_SECURED FOREIGN KEY (SECURED_REF) REFERENCES WSI_SECURED_OBJECT (PK);

CREATE SEQUENCE WSI_SNMP_QUERY;
CREATE SEQUENCE WSI_SNMP_GROUPS;
CREATE SEQUENCE WSI_SNMP_GRP_LINKS;

ALTER TABLE WSI_SNMP_GRP_LINKS ADD CONSTRAINT FK_SNMP_GROUP_LINKS_DEST FOREIGN KEY (BI_DEST_REF) REFERENCES WSI_SNMP_QUERY (PK);
ALTER TABLE WSI_SNMP_GRP_LINKS ADD CONSTRAINT FK_SNMP_GROUP_LINKS_SRC FOREIGN KEY (BI_SRC_REF) REFERENCES WSI_SNMP_GROUPS (PK);


CREATE UNIQUE INDEX IDX_SNMP_GROUP_NAME ON WSI_SNMP_GROUPS (NAME);